;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;     :                 2003 
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---

(defun C:isoline (/ vla:curve lst:textParameters int:cmdEcho int:blipMode)
  ;; ---       ---
  (setq	int:cmdEcho  (getvar "CMDECHO")
	int:blipMode (getvar "BLIPMODE")
  ) ;_ setq
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)

  ;; ---        ---
  (if (setq vla:curve (iso-getFormCurve))
    (progn
      ;; ---    ---
      (setq lst:textParameters (iso-getParameters))
      ;; ---   ---
      (if (and (> (cdr (assoc 9001 lst:textParameters)) 0)          ;   -  0
	       (> (cdr (assoc 9002 lst:textParameters)) 0.0)        ;   -  0
	       (> (strlen (cdr (assoc 9003 lst:textParameters))) 0) ;   -  0
	  ) ;_ and
	;; ---   ---
	(iso-drawText vla:curve lst:textParameters)
	(alert "     .")
      ) ;_ if
    ) ;_ progn
  ) ;_ if

  ;; ---       ---
  (setvar "CMDECHO" int:cmdEcho)
  (setvar "BLIPMODE" int:blipMode)
  (prin1)
) ;_ defun



;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;                                    2003 
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;   VLA- ,           
;;;  .               
;;; ,  nil                                                     
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---

(defun iso-getFormCurve	(/ lst:entAndPoint ent:object str:entType result)
  ;; ---    ---
  (if (setq lst:entAndPoint (entsel "\n   : "))
    (progn
      (setq ent:object	(car lst:entAndPoint)
	    str:entType	(cdr (assoc 0 (entget ent:object)))
      ) ;_ setq
      ;; ---     ---
      (if (or (= str:entType "LINE")
	      (= str:entType "POLYLINE")
	      (= str:entType "LWPOLYLINE")
	      (= str:entType "SPLINE")
	  ) ;_ or
	(setq result (vlax-ename->vla-object ent:object))
	(progn
	  (alert
	    "         ."
	  ) ;_ alert
	  (setq result nil)
	) ;_ progn
      ) ;_ if
    ) ;_ progn
    (setq result nil)
  ) ;_ if
  result				;    
) ;_ defun



;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;                                     2003 
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;              
;;;                                        
;;; :                                                                          
;;; 9001 -   ()                                                
;;; 9002 -   (  )                                      
;;; 9003 -  ()                                                     
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---

(defun iso-getParameters (/ int:dclID str:number str:height str:text)
  ;; ---      isoline.dcl ---
  (if (> (setq int:dclID (load_dialog "isoline.dcl")) 0)
    ;; ---   iso_getText ---
    (if	(new_dialog "iso_getText" int:dclID)
      (progn
	;; ---      ---
	(set_tile "number" (itoa 3))	                 ;   - 3
	(set_tile "height" (rtos (getvar "TEXTSIZE") 2)) ;   -   TEXTSIZE
	;; ---    OK ---
	(action_tile
	  "accept"
	  (strcat
	    "(setq str:number (get_tile \"number\"))"
	    "(setq str:height (get_tile \"height\"))"
	    "(setq str:text (get_tile \"text\"))"
	    "(done_dialog)"
	  ) ;_ strcat
	) ;_ action_tile
	;; ---    Cancel ---
	;; ---      ---
	(action_tile
	  "cancel"
	  (strcat
	    "(setq str:number \"0\")"
	    "(setq str:height \"0.0\")"
	    "(setq str:text \"\")"
	    "(done_dialog)"
	  ) ;_ strcat
	) ;_ action_tile
	(start_dialog)
	(unload_dialog int:dclID)
      ) ;_ progn
      (alert "    \"iso_getText\"")
    ) ;_ if
    (alert "    \"isoline.dcl\"")
  ) ;_ if
  ;; ---    ---
  (list	(cons 9001 (atoi str:number))
	(cons 9002 (atof str:height))
	(cons 9003 str:text)
  ) ;_ list
) ;_ defun



;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;                        2003 
;;;                                               
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;   VLA-           
;;;                                                                  
;;;                 
;;;       .        
;;;    .                                         
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---

(defun iso-drawText (vla:curve		lst:textParameters /		      rea:lengthOfCurve
		     rea:lengthOfPart	int:counter	   lst:angles	      lst:points
		     vla:text
		    )
  ;; ---    ---
  (setq	rea:lengthOfCurve
	 (vlax-curve-getDistAtParam
	   vla:curve
	   (vlax-curve-getEndParam vla:curve)
	 ) ;_ vlax-curve-getDistAtPoint
  ) ;_ setq
  ;; -      -     ---
  (setq rea:lengthOfPart (/ rea:lengthOfCurve (cdr (assoc 9001 lst:textParameters))))
  (setq int:counter 1)
  ;; ---       ---
  (while (<= int:counter (cdr (assoc 9001 lst:textParameters)))
    ;; ---      ---
    (setq lst:points
	   (cons (vlax-curve-getPointAtDist
		   vla:curve
		   (* rea:lengthOfPart (- int:counter 0.5))
		 ) ;_ vlax-curve-getPointAtDist
		 lst:points
	   ) ;_ cons
    ) ;_ setq
    ;; ---       ---
    (setq lst:angles
	   (cons (angle	'(0.0 0.0 0.0)
			(vlax-curve-getFirstDeriv
			  vla:curve
			  (vlax-curve-getParamAtDist
			    vla:curve
			    (* rea:lengthOfPart (- int:counter 0.5))
			  ) ;_ vlax-curve-getParamAtDist
			) ;_ vlax-curve-getFirstDeriv
		 ) ;_ angle
		 lst:angles
	   ) ;_ cons
    ) ;_ setq
    (setq int:counter (1+ int:counter))
  ) ;_ while
  ;; ---      ---
  ;; ---       ---
  (foreach a lst:angles
    (if (and (> a (* 0.5 pi))
	     (< a (* 1.5 pi))
	     )
	     (setq lst:angles (subst (+ a pi) a lst:angles)))
    )
  (setq int:counter 0)
  ;; ---     ---
  (while (< int:counter (length lst:points))
    ;; ---   ---
    (setq vla:text (vla-addText
		     (vla-get-ModelSpace
		       (vla-get-activedocument (vlax-get-acad-object))
		     ) ;_ vla-get-ModelSpace
		     (cdr (assoc 9003 lst:textParameters))
		     (vlax-3D-point (nth int:counter lst:points))
		     (cdr (assoc 9002 lst:textParameters))
		   ) ;_ vla-addText
    ) ;_ setq
    ;; ---     ---
    (vla-put-alignment vla:text acAlignmentMiddleCenter)
    ;; ---     ---
    (vla-put-textAlignmentPoint
      vla:text
      (vlax-3D-point (nth int:counter lst:points))
    ) ;_ vla-put-textAlignmentPoint
    ;; ---     ---
    (vla-put-rotation vla:text (nth int:counter lst:angles))
    ;; ---   ---
    (iso-maskText vla:text)
    (setq int:counter (1+ int:counter))
  ) ;_ while
  ;; ---   wipeout' ---
  (command "_.WIPEOUT" "_Frames" "_OFF")
) ;_ defun



;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;                                             2003 
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---
;;;   VLA-  ,      
;;;          wipeout,      
;;;                                                           
;;; ---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---

(defun iso-maskText (vla:text	       /		 lst:insertionPoint
		     lst:maskCoordinates		 lst:pointOne	   lst:pointTwo
		     lst:pointThree    lst:pointFour	 rea:rotation	   rea:x1
		     rea:x2	       rea:y1		 rea:y2
		    )
  ;; ---    ---
  (setq	lst:insertionPoint
	 (vlax-safearray->list
	   (vlax-variant-value (vla-get-insertionPoint vla:text))
	 ) ;_ vlax-safearray->list
	;; ---    ---
	rea:rotation
	 (vla-get-rotation vla:text)
	;; ---   ,     ---
	;; ---                                 ---
	lst:maskCoordinates
	 (textbox (entget (vlax-vla-object->ename vla:text)))
	;; ---     ---
	;; ---                                 ---
	rea:x1
	 (car (car lst:maskCoordinates))
	rea:y1 (cadr (car lst:maskCoordinates))
	rea:x2 (car (cadr lst:maskCoordinates))
	rea:y2 (cadr (cadr lst:maskCoordinates))
	;; ---    ,   ---
	lst:pointOne
	 (polar	lst:insertionPoint
		(+ rea:rotation (/ pi 2.0))
		rea:y1
	 ) ;_ polar
	lst:pointTwo
	 (polar lst:pointOne rea:rotation (- rea:x2 rea:x1))
	lst:pointThree
	 (polar	lst:pointTwo
		(+ rea:rotation (/ pi 2.0))
		(- rea:y2 rea:y1)
	 ) ;_ polar
	lst:pointFour
	 (polar lst:pointThree (+ rea:rotation pi) (- rea:x2 rea:x1))
  ) ;_ setq

  ;; ---  wipeout' ---
  (command "_.WIPEOUT" lst:pointOne lst:pointTwo lst:pointThree	lst:pointFour "_close")
  ;; ---  wipout' (+10%)    
  (vla-scaleEntity
    (vlax-ename->vla-object (entlast))
    (vlax-3D-point
      (inters lst:pointOne
	      lst:pointThree
	      lst:pointTwo
	      lst:pointFour
      ) ;_ inters
    ) ;_ vlax-3D-point
    1.10
  ) ;_ vla-scaleEntity
  ;; ---      ---
  ;; --- wipeout                      ---
  (command "_.DRAWORDER"
	   (entlast)
	   ""
	   "_Under"
	   (vlax-vla-object->ename vla:text)
  ) ;_ command
) ;_ defun


(princ "\n ***        \"isoline\".")